// Code generated by mockery v2.42.3. DO NOT EDIT.

package mock_client_with_responses_interface

import (
	context "context"

	api "gitlab.com/commonground/nlx/fsc-nlx/controller/adapters/authz/rest/api/client"

	io "io"

	mock "github.com/stretchr/testify/mock"

	models "gitlab.com/commonground/nlx/fsc-nlx/controller/adapters/authz/rest/api/models"
)

// MockClientWithResponsesInterface is an autogenerated mock type for the ClientWithResponsesInterface type
type MockClientWithResponsesInterface struct {
	mock.Mock
}

type MockClientWithResponsesInterface_Expecter struct {
	mock *mock.Mock
}

func (_m *MockClientWithResponsesInterface) EXPECT() *MockClientWithResponsesInterface_Expecter {
	return &MockClientWithResponsesInterface_Expecter{mock: &_m.Mock}
}

// AuthorizeWithBodyWithResponse provides a mock function with given fields: ctx, contentType, body, reqEditors
func (_m *MockClientWithResponsesInterface) AuthorizeWithBodyWithResponse(ctx context.Context, contentType string, body io.Reader, reqEditors ...api.RequestEditorFn) (*api.AuthorizeResponse, error) {
	_va := make([]interface{}, len(reqEditors))
	for _i := range reqEditors {
		_va[_i] = reqEditors[_i]
	}
	var _ca []interface{}
	_ca = append(_ca, ctx, contentType, body)
	_ca = append(_ca, _va...)
	ret := _m.Called(_ca...)

	if len(ret) == 0 {
		panic("no return value specified for AuthorizeWithBodyWithResponse")
	}

	var r0 *api.AuthorizeResponse
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string, io.Reader, ...api.RequestEditorFn) (*api.AuthorizeResponse, error)); ok {
		return rf(ctx, contentType, body, reqEditors...)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string, io.Reader, ...api.RequestEditorFn) *api.AuthorizeResponse); ok {
		r0 = rf(ctx, contentType, body, reqEditors...)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*api.AuthorizeResponse)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string, io.Reader, ...api.RequestEditorFn) error); ok {
		r1 = rf(ctx, contentType, body, reqEditors...)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// MockClientWithResponsesInterface_AuthorizeWithBodyWithResponse_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'AuthorizeWithBodyWithResponse'
type MockClientWithResponsesInterface_AuthorizeWithBodyWithResponse_Call struct {
	*mock.Call
}

// AuthorizeWithBodyWithResponse is a helper method to define mock.On call
//   - ctx context.Context
//   - contentType string
//   - body io.Reader
//   - reqEditors ...api.RequestEditorFn
func (_e *MockClientWithResponsesInterface_Expecter) AuthorizeWithBodyWithResponse(ctx interface{}, contentType interface{}, body interface{}, reqEditors ...interface{}) *MockClientWithResponsesInterface_AuthorizeWithBodyWithResponse_Call {
	return &MockClientWithResponsesInterface_AuthorizeWithBodyWithResponse_Call{Call: _e.mock.On("AuthorizeWithBodyWithResponse",
		append([]interface{}{ctx, contentType, body}, reqEditors...)...)}
}

func (_c *MockClientWithResponsesInterface_AuthorizeWithBodyWithResponse_Call) Run(run func(ctx context.Context, contentType string, body io.Reader, reqEditors ...api.RequestEditorFn)) *MockClientWithResponsesInterface_AuthorizeWithBodyWithResponse_Call {
	_c.Call.Run(func(args mock.Arguments) {
		variadicArgs := make([]api.RequestEditorFn, len(args)-3)
		for i, a := range args[3:] {
			if a != nil {
				variadicArgs[i] = a.(api.RequestEditorFn)
			}
		}
		run(args[0].(context.Context), args[1].(string), args[2].(io.Reader), variadicArgs...)
	})
	return _c
}

func (_c *MockClientWithResponsesInterface_AuthorizeWithBodyWithResponse_Call) Return(_a0 *api.AuthorizeResponse, _a1 error) *MockClientWithResponsesInterface_AuthorizeWithBodyWithResponse_Call {
	_c.Call.Return(_a0, _a1)
	return _c
}

func (_c *MockClientWithResponsesInterface_AuthorizeWithBodyWithResponse_Call) RunAndReturn(run func(context.Context, string, io.Reader, ...api.RequestEditorFn) (*api.AuthorizeResponse, error)) *MockClientWithResponsesInterface_AuthorizeWithBodyWithResponse_Call {
	_c.Call.Return(run)
	return _c
}

// AuthorizeWithResponse provides a mock function with given fields: ctx, body, reqEditors
func (_m *MockClientWithResponsesInterface) AuthorizeWithResponse(ctx context.Context, body models.AuthorizationRequest, reqEditors ...api.RequestEditorFn) (*api.AuthorizeResponse, error) {
	_va := make([]interface{}, len(reqEditors))
	for _i := range reqEditors {
		_va[_i] = reqEditors[_i]
	}
	var _ca []interface{}
	_ca = append(_ca, ctx, body)
	_ca = append(_ca, _va...)
	ret := _m.Called(_ca...)

	if len(ret) == 0 {
		panic("no return value specified for AuthorizeWithResponse")
	}

	var r0 *api.AuthorizeResponse
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, models.AuthorizationRequest, ...api.RequestEditorFn) (*api.AuthorizeResponse, error)); ok {
		return rf(ctx, body, reqEditors...)
	}
	if rf, ok := ret.Get(0).(func(context.Context, models.AuthorizationRequest, ...api.RequestEditorFn) *api.AuthorizeResponse); ok {
		r0 = rf(ctx, body, reqEditors...)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*api.AuthorizeResponse)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, models.AuthorizationRequest, ...api.RequestEditorFn) error); ok {
		r1 = rf(ctx, body, reqEditors...)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// MockClientWithResponsesInterface_AuthorizeWithResponse_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'AuthorizeWithResponse'
type MockClientWithResponsesInterface_AuthorizeWithResponse_Call struct {
	*mock.Call
}

// AuthorizeWithResponse is a helper method to define mock.On call
//   - ctx context.Context
//   - body models.AuthorizationRequest
//   - reqEditors ...api.RequestEditorFn
func (_e *MockClientWithResponsesInterface_Expecter) AuthorizeWithResponse(ctx interface{}, body interface{}, reqEditors ...interface{}) *MockClientWithResponsesInterface_AuthorizeWithResponse_Call {
	return &MockClientWithResponsesInterface_AuthorizeWithResponse_Call{Call: _e.mock.On("AuthorizeWithResponse",
		append([]interface{}{ctx, body}, reqEditors...)...)}
}

func (_c *MockClientWithResponsesInterface_AuthorizeWithResponse_Call) Run(run func(ctx context.Context, body models.AuthorizationRequest, reqEditors ...api.RequestEditorFn)) *MockClientWithResponsesInterface_AuthorizeWithResponse_Call {
	_c.Call.Run(func(args mock.Arguments) {
		variadicArgs := make([]api.RequestEditorFn, len(args)-2)
		for i, a := range args[2:] {
			if a != nil {
				variadicArgs[i] = a.(api.RequestEditorFn)
			}
		}
		run(args[0].(context.Context), args[1].(models.AuthorizationRequest), variadicArgs...)
	})
	return _c
}

func (_c *MockClientWithResponsesInterface_AuthorizeWithResponse_Call) Return(_a0 *api.AuthorizeResponse, _a1 error) *MockClientWithResponsesInterface_AuthorizeWithResponse_Call {
	_c.Call.Return(_a0, _a1)
	return _c
}

func (_c *MockClientWithResponsesInterface_AuthorizeWithResponse_Call) RunAndReturn(run func(context.Context, models.AuthorizationRequest, ...api.RequestEditorFn) (*api.AuthorizeResponse, error)) *MockClientWithResponsesInterface_AuthorizeWithResponse_Call {
	_c.Call.Return(run)
	return _c
}

// NewMockClientWithResponsesInterface creates a new instance of MockClientWithResponsesInterface. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockClientWithResponsesInterface(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockClientWithResponsesInterface {
	mock := &MockClientWithResponsesInterface{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
